class PetersonLock implements Lock {
   private volatile boolean enter0 = false, enter1 = false;
   private volatile int yield;

   public void lock() {
     int me = getThreadId();
     if (me == 0) enter0 = true; else enter1 = true;
     yield = me;
     while ((me == 0) ? (enter1 && yield == 0) 
                      : (enter0 && yield == 1)) {}
   }

   public void unlock() {
     int me = getThreadId();
     if (me == 0) enter0 = false; else enter1 = false;
   }

   private volatile long id0 = 0;
   private int getThreadId() {
     if (id0 == 0)
       id0 = Thread.currentThread().getId();
     long me = Thread.currentThread().getId();
     return (me == id0) ? 0 : 1;
   }
}
